/*
    Copyright (C) 1998  Michael Ravits

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _PLAYLIST_H
#define _PLAYLIST_H

class playlist
{
  private:
	const		block_size = 32;
	char		**play_list;
	int		songs_num;
	int		list_size;
	bool		playing;
	int		position;
	void		free_list(void);
	char		*path_and_file;
	char		*curr_path;
	char		*some_str;
	ListPlay	list_play_method;
	int		random_song(void);
	bool		input_window_active;
  public:
  	playlist(void);
	~playlist(void);
	void		add_to_playlist(char *);
	//if song is found in the playlist it's place is returned
	//else -1 is returned.
	int		in_playlist(char *);
	void		remove_from_playlist(int);
	void		sort_alpha(void);
	void		play_the_list(class player &, bool);
	void		play_the_list_alpha(class player &, bool);
	void		play_the_list_random(class player &);
	void		play_prev_song_in_list(class player &, bool);
	void		goto_first_song_in_list(class player &, bool);
	void		goto_last_song_in_list(class player &, bool);
	bool		is_playing(void);
	void		reset_playing(void);
	void		give_path_and_file(char *);
	void		set_play_method(ListPlay);
	void		toggle_play_method(void);
	ListPlay	rplay_method(void);
	void		remove_all_from_playlist(void);
	void		save_playlist(screen &, stuff &, player &);
	bool		is_input_window_active(void);
	void		load_playlist(char *);
	void		fix_string(char *, char *);
};

#endif
